unit UnitFrameKeystrokeList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, Buttons, ComCtrls;

type
  TFrameKeystrokeList = class(TFrame)
    lvKeystrokes: TListView;
    pmEdit: TPopupMenu;
    btnAdd: TSpeedButton;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    btnSet: TSpeedButton;
    btnCancel: TSpeedButton;
    SpeedButton1: TSpeedButton;
    pmInsert: TPopupMenu;
    MinimizeAltSpaceM1: TMenuItem;
    MaximizeAltSpaceX1: TMenuItem;
    RestoreAltSpaceR1: TMenuItem;
    FileSaveAltFS1: TMenuItem;
    N1: TMenuItem;
    FileNewALTFN1: TMenuItem;
    N2: TMenuItem;
    ClearList1: TMenuItem;
    procedure btnAddClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnSetClick(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure MinimizeAltSpaceM1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure ClearList1Click(Sender: TObject);
  private
    { Private declarations }
    keys : TStringList;
  public
    { Public declarations }
    function GetKeystrokeList(sl : TStringList; initdata : string = '') : boolean;
    procedure SetKeystrokeList(initdata : string);
    procedure Init;
    constructor create(AOwned : TComponent); override;
  end;

var
  FrameKeystrokeList: TFrameKeystrokeList;

implementation

uses UnitFrmHotKey, UnitToken, UnitMisc;

{$R *.dfm}

procedure TFrameKeystrokeList.btnAddClick(Sender: TObject);
var kd : TKeystrokeData;
    li : TListItem;
begin
    if FrmKeystrokeEdit.GetHotKey(kd, true)  then begin
        li := lvKeystrokes.Items.Add;
        li.caption := kd.name;
        keys.Values[kd.name] := FrmKeystrokeEdit.ToString(kd);
    end;
end;

procedure TFrameKeystrokeList.btnCancelClick(Sender: TObject);
begin
    //Self.ModalResult := mrCancel;
end;

procedure TFrameKeystrokeList.btnSetClick(Sender: TObject);
begin
    //self.ModalResult := mrOK;
end;

procedure TFrameKeystrokeList.ClearList1Click(Sender: TObject);
begin
    keys.Clear;
    lvKeystrokes.Clear;
end;

constructor TFrameKeystrokeList.create(AOwned : TComponent);
begin
    inherited create(AOwned);

    keys := TStringList.Create;
end;

procedure TFrameKeystrokeList.Delete1Click(Sender: TObject);
begin
    try
        keys.values[lvKeystrokes.Selected.caption] := '';
        lvKeystrokes.Selected.Delete;
    except
        // ignore no selection
    end;
end;

procedure TFrameKeystrokeList.Edit1Click(Sender: TObject);
var kd : TKeystrokeData;
begin
    try
        keys.values[lvKeystrokes.Selected.caption] := '';
        if FrmKeystrokeEdit.GetHotKey(kd, true)  then begin
            keys.Values[lvKeystrokes.selected.Caption] := '';
            lvKeystrokes.Selected.caption := kd.name;
            keys.Values[kd.name] := FrmKeystrokeEdit.ToString(kd);
        end;
    except
        // ignore no selection
    end;
end;

function TFrameKeystrokeList.GetKeystrokeList(sl: TStringList; initdata : string = ''): boolean;
var i : integer;
    kd : TKeystrokeData;
    li : TListItem;
begin
    //lvKeystrokes.Clear;
    {while initdata <> '' do begin
        kd := FrmKeystrokeEdit.FromString( TokenString(initdata, '|') );
        keys.values[kd.name] := FrmKeystrokeEdit.ToString(kd);
        li := lvKeystrokes.Items.add;
        li.Caption := kd.name;
    end;
    }
    //self.ShowModal;
    //result := self.ModalResult = mrOk;
    //if  result then begin
        sl.clear;
        for i := 0 to lvKeystrokes.items.count - 1 do begin
            li := lvKeystrokes.Items[i];
            sl.Add(keys.Values[li.caption]);
            //sl.values[li.caption] := ;
        end;

    //end;
end;

procedure TFrameKeystrokeList.Init;
begin
    if not assigned(keys) then
        keys := TStringList.Create;

    ClearList1.Click;
end;

procedure TFrameKeystrokeList.MinimizeAltSpaceM1Click(Sender: TObject);
var data : string;
    kd : TKeystrokeData;
    li : TListItem;
begin

    keys.Clear;
    lvKeystrokes.Clear;
    data := TMenuItem(sender).hint;
    while data <> '' do begin
        kd := FrmKeystrokeEdit.FromString( TokenSTring(data, '|') );

        li := lvKeystrokes.Items.Add;
        li.caption := kd.name;
        keys.Values[kd.name] := FrmKeystrokeEdit.ToString(kd);
    end;
end;

procedure TFrameKeystrokeList.SetKeystrokeList(initdata: string);
var kd : TKeystrokeData;
    li : TListItem;
begin
    lvKeystrokes.Clear;
    while initdata <> '' do begin
        kd := FrmKeystrokeEdit.FromString( TokenString(initdata, '|') );
        keys.values[kd.name] := FrmKeystrokeEdit.ToString(kd);
        li := lvKeystrokes.Items.add;
        li.Caption := kd.name;
    end;

end;

procedure TFrameKeystrokeList.SpeedButton1Click(Sender: TObject);
begin
    pmInsert.Popup(mouse.CursorPos.X + 10, mouse.CursorPos.Y + 10);
end;

end.
